WQAchievements = LibStub("AceAddon-3.0"):NewAddon("WQAchievements", "AceEvent-3.0", "AceConsole-3.0", "AceTimer-3.0")
local WQA = WQAchievements
local IsActive = C_TaskQuest.IsActive
local defaults = {
	char = {
		pvp = {id = 11474, status = true},
		ff = {id = 9696, status = true},
		botbi = {id = 10876, status = true},
		fishing = {id = 10598, status = true}
	}
}

WQA:RegisterChatCommand("wqa", "slash")

function WQA:slash(input)
	local arg1 = string.lower(input)

	if arg1 == "" then
		self:checkWQ()
	elseif arg1 == "details" then
		self:checkWQ("details")
	elseif self.db.char[arg1] then
		print("Tracking of "..GetAchievementLink(self.db.char[arg1].id).." is now "..tostring(not self.db.char[arg1].status))
		self.db.char[arg1].status = not self.db.char[arg1].status
		self:buildQList()
	elseif arg1 == "?" then
		for k,v in pairs(self.db.char) do
			print("Tracking of "..GetAchievementLink(v.id).." is "..tostring(v.status))
			print("Toggle tracking with /wqa "..k)
		end
	end
end

WQA.aL = {}
WQA.aL.pvp = {11475, 11476, 11477, 11478}
WQA.aL.ff = {9686, 9687, 9688, 9689, 9690, 9691, 9692, 9693, 9694, 9695}
WQA.aL.botbi = {10876}
WQA.aL.fishing = {10598}
WQA.trainerList = {42159, 40299, 40277, 42442, 40298, 40280, 40282, 41687, 40278, 41944, 41895, 40337, 41990, 40279, 41860}
WQA.fishQList = {}
WQA.fishQList[1] = {41612, 41613, 41270}
WQA.fishQList[3] = {41604, 41605, 41279}
WQA.fishQList[4] = {41598, 41599, 41264}
WQA.fishQList[7] = {41611, 41265, 41610}
WQA.fishQList[8] = {41617, 41280, 41616}
WQA.fishQList[9] = {41597, 41244, 41596}
WQA.fishQList[10] = {41602, 41274, 41603}
WQA.fishQList[11] = {41609, 41243}
WQA.fishQList[14] = {41615, 41275, 41614}
WQA.fishQList[19] = {41269, 41600, 41601}
WQA.watched = {}

function WQA:buildQList()
	WQA.questList = {}
	for k,v in pairs(self.db.char) do
		if v.status == true then
			for _,id in pairs(WQA.aL[k]) do
				local _,_,_,completed = GetAchievementInfo(id)
				if completed == false then
					for i=1, GetAchievementNumCriteria(id) do
						local _,t,completed,_,_,_,_,questId = GetAchievementCriteriaInfo(id,i)
						if completed == false then
							if id == 10598 and t == 0 then
								for _,questId in pairs(self.fishQList[i]) do
							 		if not self.questList[questId] then self.questList[questId] = {} end
							 		local l = self.questList[questId]
									l[#l + 1] = id
								end
							else
								if t == 158 then questId = self.trainerList[i] end
								
								if not self.questList[questId] then self.questList[questId] = {} end
								local l = self.questList[questId]
								l[#l + 1] = id
							end
						end
					end
				end
			end
		end
	end
end

function WQA:checkWQ(mode)
	for qID,qList in pairs(self.questList) do
		if IsActive(qID) and not (self.watched[qID] and mode == "new") then
			self.watched[qID] = true
			print(GetQuestLink(qID))
			if mode == "details" then
				for _,aID in pairs(qList) do
					print("     "..GetAchievementLink(aID))
				end
			end
		end
	end
end

function WQA:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("WQADB", defaults)
end

function WQA:OnEnable()
	self:ScheduleTimer("buildQList",4)
	self:ScheduleTimer("checkWQ",10)
	self:ScheduleRepeatingTimer("checkWQ",300,"new")
end